// WindowSnapper.h

#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Drawing;
using namespace System::Windows::Forms;

namespace NickHod
{
namespace Drawing
{
	private __gc class ThisAssembly
	{
	};

	// The bitmap for this component lives in file NickHod.Drawing.WindowSnapper.bmp
	// It is bound to the assembly with the compiler switch /ASSEMBLYRESOURCE
	[ToolboxBitmapAttribute(__typeof(ThisAssembly), S"WindowSnapper.bmp") ]
	public __gc class WindowSnapper :
		public System::ComponentModel::Component
	{
	private:

		Bitmap*				m_pBitmap;

		bool					m_IncludeMousePointer;
	
	private:

								// hidden C++ destructor
							  ~WindowSnapper();

	public:

								// construct
								WindowSnapper();

		void					SnapDesktopWindow();

		void					SnapForegroundWindow();

		void					SnapWindow(IntPtr hWindow);

		void					SnapWindow(NativeWindow* Window);

		void					SnapWindow(Control* ControlOrForm);

		[BrowsableAttribute(false)]
		__property Bitmap* 
								get_CurrentSnapshot(void);

		__property bool	get_IncludeMousePointer(void);
		__property void	set_IncludeMousePointer(bool IncludeMousePointer);

		__event EventHandler*	
								Snapped;

	};

} // namespace Multimedia
} // namespace NickHod
