//*****************************************************************************
//
//      Class:          IconItem
//      Namespace:      Kerr.IconBrowser
//      Date created:   15 June 2001
//      Copyright:       Kenny Kerr 2002    http://www.kennyandkarin.com
//
//*****************************************************************************

#include "stdafx.h"
#include "IconItem.h"

namespace Kerr { namespace IconBrowser
{
    //
    // Creates a new ListViewItem to represent the specified IconResource.
    //
    IconItem::IconItem(IconBrowser::IconResource* iconResource,
                       int iImageIndex) :
        m_iconResource(iconResource)
    {
        Debug::Assert(0 != iconResource);

        ImageIndex = iImageIndex;
        Text = m_iconResource->Text;
    }

    //
    // Gets the IconResource that the ListViewItem represents.
    //
    IconBrowser::IconResource* IconItem::get_IconResource()
    {
        return m_iconResource;
    }
}}
