//*****************************************************************************
//
//      Class:          IconItem
//      Namespace:      Kerr.IconBrowser
//      Date created:   15 June 2001
//      Copyright:       Kenny Kerr 2002    http://www.kennyandkarin.com
//
//*****************************************************************************

#pragma once

#include "IconResource.h"

namespace Kerr { namespace IconBrowser
{
    //
    // ListViewItem-derived class to represent an IconResource.
    //
    __gc class IconItem : public System::Windows::Forms::ListViewItem
    {
    public:
        
    // Construction/destruction

        IconItem(IconBrowser::IconResource* iconResource,
                 int iImageIndex);

    // Properties

        __property IconBrowser::IconResource* get_IconResource();

    private:

    // Data members

        IconBrowser::IconResource* m_iconResource;
    };
}};
